<?php
/*
 * @package Joomla 1.5
 * @copyright Copyright (C) 2005 Open Source Matters. All rights reserved.
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
 *
 * @plugin J2top
 * @copyright Copyright (C) Jan Pavelka www.phoca.cz
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 */
defined('JPATH_BASE') or die();

class JElementJ2topColorText extends JElement
{
	var	$_name 			= 'j2topcolortext';
	var $_J2topParams 	= null;

	function fetchElement($name, $value, &$node, $control_name)
	{

		$document	= &JFactory::getDocument();
		$option 	= JRequest::getCmd('option');

		$globalValue = &$this->_getJ2topParameter( $name );

		// Color Picker
		JHTML::stylesheet( 'picker.css', JURI::root().'/plugins/system/J2top/elements/jcp/' );
		$document->addScript(JURI::root().'/plugins/system/J2top/elements/jcp/picker.js');


		$size = ( $node->attributes('size') ? 'size="'.$node->attributes('size').'"' : '' );
		$class = ( $node->attributes('class') ? 'class="'.$node->attributes('class').'"' : 'class="text_area"' );
        $onchange = ( $node->attributes('onchange') ? 'onchange="'.$node->attributes('onchange').'"' : '' );
        /*
         * Required to avoid a cycle of encoding &
         * html_entity_decode was used in place of htmlspecialchars_decode because
         * htmlspecialchars_decode is not compatible with PHP 4
         */
        $value = htmlspecialchars(html_entity_decode($value, ENT_QUOTES), ENT_QUOTES);

		// MENU - Set default value to "" because of saving "" value into the menu link ( use global = "")
		if ($option == "com_menus") {
			$defaultValue	= $node->attributes('default');
			if ($value == $defaultValue) {
				$value = '';
			}
		}

        $background = ' style="background-color: '.$value.'"';

		$html ='<input type="text" name="'.$control_name.'['.$name.']" id="'.$control_name.$name.'" value="'.$value.'" '.$class.' '.$size.' '.$background.' '.$onchange.' onfocus="this.style.background=\'#ffffff\';" />';
		
		// Color Picker
		$html .= '<span style="margin-left:10px" onclick="openPicker(\''.$control_name.$name.'\')"  class="picker_buttons">' . JText::_('Pick color') . '</span>';
		
		// MENU - Display the global value
		if ($option == "com_menus") {
			$html .= '<span style="margin-left:10px;">[</span><span style="background:#fff"> ' . $globalValue . ' </span><span>]</span>';
		}
	return $html;
	}
	
	function _setJ2topParams(){

        $this->_plugin = JPluginHelper::getPlugin( 'system', 'J2top' );
		$plugin->params = new JParameter( $this->_plugin->params );
		$this->_J2topParams	= $plugin->params;
	}

	function _getJ2topParameter( $name ){
	
		// Don't call sql query by every param item (it will be loaded only one time)
		if (!$this->_J2topParams) {
			$params = &$this->_setJ2topParams();
		}
		$globalValue 	= &$this->_J2topParams->get( $name, '' );
		return $globalValue;
	}
}
?>